(function() {
    var fs, args, files, filesBrowser, rose, rose_unstable, code, name, _i, _ref, _err;
    fs = require("fs");
    args = require("yargs")["argv"];
    files = ["index", "functions", "utils", "operators", "tokenise", "lex", "parse", "register", "repl", "optparse", "command", "macros", "uniq", "rose", "browser"];
    filesBrowser = ["utils", "functions", "operators", "tokenise", "lex", "parse", "macros", "uniq", "rose", "browser"];

    function buildFile(compiler, filename, srcDir, destDir) {
      var srcPath, destPath, src, js;
      srcPath = srcDir + filename + ".rose";
      destPath = destDir + filename + ".js";
      src = fs.readFileSync(srcPath, "utf8");
      console.log("-- compiling " + filename + "...");
      js = compiler.compile(src);
      return fs.writeFileSync(destPath, js, "utf8");
    }
    buildFile;

    function build(rose, srcDir, destDir) {
      var filename, _i, _ref;
      console.log("-- building...");
      _ref = files;
      for (_i = 0; _i < _ref.length; ++_i) {
        filename = _ref[_i];
        buildFile(rose, filename, srcDir, destDir);
      }
      return console.log("-- if you're reading this, compilation has succeeded!");
    }
    build;
    if (args.r) {
      console.log("-- trying to load stable compiler...");
      rose = require("./lib/rose/rose");
      console.log("-- rebuilding dev with stable...");
      build(rose, "./src/", "./dev/rose/");
    } else if (args.s) {
      console.log("-- trying to load unstable compiler...");
      rose_unstable = require("./dev/rose/rose");
      console.log("-- trying to build lib with unstable compiler...");
      build(rose_unstable, "./src/", "./lib/rose/");
    } else {
      console.log("-- trying to load unstable compiler...");
      rose_unstable = require("./dev/rose/rose");
      console.log("-- trying to build dev with unstable compiler...");
      build(rose_unstable, "./src/", "./dev/rose/");
      console.log("-- when testing the unstable version, recompile at least twice!");
    }
    code = "";
    _ref = filesBrowser;
    for (_i = 0; _i < _ref.length; ++_i) {
      name = _ref[_i];
      code += ("require['./" + name + "'] = (function() {\
        n
        var exports = {}, module = {
          exports: exports
        };\ n " + fs.readFileSync(". / dev / rose / " + name + ".js ") + "\
        n
        return module.exports;\ n
      })();
    "); }  code = "(function(root) {
      \
      n
      var rose = function() {
        \
        n
        function require(path) {
          return require[path];
        }\
        n " + code + "\
        n
        return require['./rose'];\
        n
      }();\
      n root.rose = rose;\
      n
    }(this));
    "; fs.writeFileSync(". / browser / rose.js ", code); console.log("--
    if you 're reading this, concat build has succeeded!"); try { fs.writeFileSync("./node_modules/rose/browser/rose.js", code); console.log("-- replaced the browser module in ./node_modules/rose/browser/rose.js for gh-pages testing"); } catch (_err) {  } return; })['
    call '](this);